function [path] = navigatial(obstacles1, count, size, goal, start)
global obs;
global cnt;
global gl;
global path;
path=[];
gl = goal;
obs = obstacles1;
cnt = count;
global tym;
tym=0;
%display('Starttttttttttttttttttttttttttttt');
%disp(start);
%display('Goalllllllllllllllllllllll');
%disp(goal);


refine = 4;
options = odeset('Events',@stopCondition2,'RelTol',1e-6,'AbsTol',1e-8,'Refine',refine);

[time,axises,te,ye,ie] = ode45(@navigatialg, [0 1e8], start, options);
x= axises(:,1);
y=  axises(:,2);
%display('lengthhhhhhhhhhhhhhhhhhhhhhhhhhhhhh');
%disp(length(x(:,1)));
tic;
%area2 = navigation(obstacles, count, 2.7, 100)
zet = toc;
zet = 0;



function deriv2 = navigatialg(t,z)
global obs;
global cnt;
global gl;
global path;
%display('naviga');
%disp(t);
%disp(length(z(:,1)));
%tym=tym+1;
%disp('running');
try
    path(length (path(:,1)) + 1, 1) = z(1);
    path(length (path(:,1)), 2) = z(2);

catch
    path(1,1) = z(1);
    path(1,2) = z(2);
    %display ('here1');
    %disp (path (1,1));
    %disp(path(1,2));
    %display('here2');
end

 coeff = 2.7;
point = z';
deriv = zeros(2,1);
beta = -1 * ones(cnt + 1);
deltabeta = -1 * ones(cnt + 1, 2);

beta(1) =  2500 - (50 - point(1))^2 - (50 - point(2))^2;
deltabeta(1, 1) = -2 * (point(1) - 50);
deltabeta(1, 2) = -2 * (point(2) - 50);

for x=1:cnt
    current = obs{x};
    beta(x + 1) = - current(3)^2 + (current(1) - point(1))^2 + (current(2) - point(2))^2;
    deltabeta(x + 1, 1) = 2 * (point(1) - current(1));
    deltabeta(x + 1, 2) = 2 * (point(2) - current(2));    
end
for x=1:cnt+1 
    for y=1:cnt+1
        if x == y
            continue;
        else
            deltabeta(x, :) = deltabeta(x, :) * beta(y); 
        end
            
    end
    
end

mbeta = beta(1);
sdbeta(1) = deltabeta(1, 1);
sdbeta(2) = deltabeta(1, 2);
for x=1:cnt
    mbeta = mbeta * beta(x + 1);
    sdbeta(1) = sdbeta(1) + deltabeta(x + 1, 1);
    sdbeta(2) = sdbeta(2) + deltabeta(x + 1, 2);
end
Dbeta(1) = sdbeta(1);
Dbeta(2) = sdbeta(2);

Dspec = (1/coeff)*(sqrt((point(1) - gl(1))^2 + (point(2) - gl(2))^2)^(2*coeff)+mbeta)^(1/coeff-1) * (2* coeff * ((point(1) - gl(1))^2 + (point(2) - gl(2))^2)^(coeff-1)* (point-gl) + Dbeta) ;

deriv =(2* (point-gl) * (sqrt((point(1) - gl(1))^2 + (point(2) - gl(2))^2)^(2*coeff)+mbeta)^(1/coeff) - ((point(1) - gl(1))^2 + (point(2) - gl(2))^2) * Dspec) / (sqrt((point(1) - gl(1))^2 + (point(2) - gl(2))^2)^(2*coeff)+mbeta)^(2/coeff);
deriv2 = deriv';
deriv2(1) = -deriv(1);
deriv2(2) = -deriv(2);


function [sum,isterminal,direction] = stopCondition2(t,z)
% Locate the time when height passes through zero in a 
% decreasing direction and stop integration.
%display('stop');
%disp(t);
%disp(z);
cond = 1e-5;
global obs;
global cnt;
global gl;
global tym;

%tym=tym+1;
%disp(tym);
flg=0;
%coeff = 2;
coeff = 2.7;
point = z';
deriv = zeros(2,1);
beta = -1 * ones(cnt + 1);
deltabeta = -1 * ones(cnt + 1, 2);

beta(1) =  2500 - (50 - point(1))^2 - (50 - point(2))^2;
deltabeta(1, 1) = -2 * (point(1) - 50);
deltabeta(1, 2) = -2 * (point(2) - 50);

for x=1:cnt
    current = obs{x};
    beta(x + 1) = - current(3)^2 + (current(1) - point(1))^2 + (current(2) - point(2))^2;
    deltabeta(x + 1, 1) = 2 * (point(1) - current(1));
    deltabeta(x + 1, 2) = 2 * (point(2) - current(2));
    
end
for x=1:cnt+1 
    for y=1:cnt+1
        if x == y
            continue;
        else
            deltabeta(x, :) = deltabeta(x, :) * beta(y); 
        end
            
    end
    
end
mbeta = beta(1);
sdbeta(1) = deltabeta(1, 1);
sdbeta(2) = deltabeta(1, 2);
for x=1:cnt
    mbeta = mbeta * beta(x + 1);
    sdbeta(1) = sdbeta(1) + deltabeta(x + 1, 1);
    sdbeta(2) = sdbeta(2) + deltabeta(x + 1, 2);
end
Dbeta(1) = sdbeta(1);
Dbeta(2) = sdbeta(2);

beta(1) =  2500 - (50 - point(1))^2 - (50 - point(2))^2;
deltabeta(1, 1) = -2 * (point(1) - 50);
deltabeta(1, 2) = -2 * (point(2) - 50);

for x=1:cnt
    current = obs{x};
    beta(x + 1) = - current(3)^2 + (current(1) - point(1))^2 + (current(2) - point(2))^2;
    deltabeta(x + 1, 1) = 2 * (point(1) - current(1));
    deltabeta(x + 1, 2) = 2 * (point(2) - current(2));
    
end
for x=1:cnt+1
    temp = deltabeta(x, :);
    deltabeta(x, :) = [0 0]; 
    for y=1:cnt+1
        if x == y
            continue;
        else
            deltabeta(x, :) = deltabeta(x, :) + temp * beta(y); 
        end
            
    end
    
end

mbeta = beta(1);
sdbeta(1) = deltabeta(1, 1);
sdbeta(2) = deltabeta(1, 2);
for x=1:cnt
    mbeta = mbeta * beta(x + 1);
    sdbeta(1) = sdbeta(1) + deltabeta(x + 1, 1);
    sdbeta(2) = sdbeta(2) + deltabeta(x + 1, 2);
end
Dbeta(1) = sdbeta(1);
Dbeta(2) = sdbeta(2);

Dspec = (1/coeff)*(sqrt((point(1) - gl(1))^2 + (point(2) - gl(2))^2)^(2*coeff)+mbeta)^(1/coeff-1) * (2* coeff * ((point(1) - gl(1))^2 + (point(2) - gl(2))^2)^(coeff-1)* (point-gl) + Dbeta) ;

deriv =(2* (point-gl) * (sqrt((point(1) - gl(1))^2 + (point(2) - gl(2))^2)^(2*coeff)+mbeta)^(1/coeff) - ((point(1) - gl(1))^2 + (point(2) - gl(2))^2) * Dspec) / (sqrt((point(1) - gl(1))^2 + (point(2) - gl(2))^2)^(2*coeff)+mbeta)^(2/coeff);
deriv = deriv';
%if(flg==0)
  %{  
disp(point);
    disp('---');
    disp(deriv(1));
    disp('-----');
    disp(deriv(2));
    
    
    flg=1;
    %}
%end
%disp('its over');
sum = [(norm(deriv)>cond) *1  norm(gl-point)<cond] ; % stop when the norm of the gradiant is less than or equal to epsilon    

isterminal = [1 1];   % Stop the integration
direction = [0 0];   % any direction
