function [parent, nodes, tree] = rrtConnector(from,to, no_sampling, obstacles,obstacles1,size,count, temporary) 

isSuccess = 0;
tree = [];
node = [from(1),from(2)];
nodes(1,:) = node;
final = [];
parent = [];
dist = [];

dist(1,:) = 0;
parent(1,:) = 1;

for k=1:no_sampling + 1
    disp(k);
   if (k == no_sampling + 1)
       point = to(:);
   else
       point=temporary(k,:);
      % display('RRT');
       % disp(point);
       %disp(point);
   end
   neighbours = [];
   final(k,:) = point;
   if k == 1
       stateno = 1;
   else
       stateno = length(nodes(:,1));
   end
   
   %mindistance = -1;
   %minindex = -1;
   
   for l=1:stateno
       current = sqrt((nodes(l,1) - point(1))^2 + (nodes(l,2) - point(2))^2);
       if (l == 1)
           neighbours(1,:) = [nodes(l,1), nodes(l,2), current, l];
       else
           neighbours(length(neighbours(:,1)) + 1,:)=[nodes(l,1), nodes(l,2), current, l];
       end
   end
       
   %step1= (point(1) - nodes(minindex, 1))/fragments;
   %step2= (point(2) - nodes(minindex, 2))/fragments;
   
   %curr = nodes(minindex,:);
   %for l=1:fragments
   %    points = [curr(1)+l*step1 curr(2)+l*step2];
   %    epoints = [curr(1)+(l-1)*step1 curr(2)+(l-1)*step2];
   %   isCollide = stepCollisionCheck(points, epoints, obstacles);
   %    if isCollide
   %        break;
   %    end
   %end
    
   upper_bound = 0;
   %if not (isCollide)
        
   neighbours = sortrows(neighbours,3);
   L = length (neighbours(:,1));

   dist(stateno + 1) = 100000;
    
   curr = [];
   flag = 0;
   minindex = -1;
   for i=1:min(20,L)
       current = sqrt((neighbours(i,1) - point(1))^2 + (neighbours(i,2) - point(2))^2);
       if (current + dist(neighbours(i, 4)) < dist (stateno + 1))
           check = stepCollisionCheck (point, neighbours(i,:), obstacles);
           if not (check)
               flag = 1;
               curr = nodes(neighbours(i, 4),:);
               minindex = neighbours(i,4);
               dist(stateno + 1)=current + dist(neighbours(i,4));
           end
       end
   end
       
   if (flag == 1)
       try
           tree(length(tree(:,1)) + 1,:) = [curr(:); point(:)];
           upper_bound = length(tree(:,1));
       catch
           tree(1,:) = [curr(:); point(:)];
           upper_bound = 1;
       end
       
       for i=1:min(20,L)
           current = sqrt((neighbours(i,1) - point(1))^2 + (neighbours(i,2) - point(2))^2);
           if (current + dist(stateno + 1) < dist (neighbours(i,4)))
               idx = 1;
               for j=1:upper_bound
                   p1 = tree(j,3);
                   p2 = tree(j,4);
                   if (p1 == neighbours(i,1) && p2 == neighbours(i,2))
                       idx = j;
                       break;
                   end
               end
               check = stepCollisionCheck (point, neighbours(i,:),obstacles);
               if not (check)
                   tree(j,1)=point(1);
                   tree(j,2)=point(2);
                   dist(neighbours(i,4))=current + dist(stateno + 1);
               end
           end
               
       end
       parent(length(parent(:,1))+1,:) = minindex;
       nodes(length(nodes(:,1)) + 1,:) = point(:);
   end
end
   
%{
len=length(nodes(:,1));
cnt=0;
for k=1:no_sampling
    isCollide=stepCollisionCheck(final(k,:), to, obstacles);
    if (isCollide)
        continue;
    end
    to_1=[to(1);to(2)];
    nodes_1=[final(k,1);final(k,2)];
    newnode = [nodes_1(:);to_1(:)];
    if not (isCollide)
        try
          tree(length(tree(:,1)) + 1,:) = newnode(:);
        catch
          tree(1,:) = newnode(:);
        end
    end
%}
end