function isIntersecting = stepCollisionCheck (first, second, obstacles)

isIntersecting = 0;
for k=1:length(obstacles)
    x = obstacles {k}(:,1);
    y = obstacles {k}(:,2);
    A = inpolygon(first(1), first(2), x, y);
    if (A == 1)
        isIntersecting = 1;
        break;
    end
    
    A = inpolygon(second(1), second(2), x, y);
    if (A == 1)
        isIntersecting = 1;
        break;
    end
    
    A = polyxpoly([first(1) second(1)], [first(2) second(2)], x, y);
    if not(isempty (A))
        isIntersecting = 1;
        break;
    end
end